/* --- The following code comes from C:\PROGTOOL\LCC\lib\wizard\textmode.tpl. */
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

#define Z80BUSREQ_H 0x10
#define Z80BUSREQ_L 0x00
#define Z80RESET 0x20
#define Z80WR 0x40

int GetHex( unsigned char *AsciiHex );
int Get8Hex( unsigned char *AsciiHex );
void WritePort( unsigned char EEData, unsigned char EEAddrL, unsigned char EEAddrH, HANDLE ProgPort );

int main(int argc,char *argv[])
{


	int x;
	unsigned int RecLen;
	unsigned int LoadOffset;
	HANDLE ProgPort;
	DWORD  lpNumberOfBytesWritten;

	unsigned char HexData[550];
	unsigned char EEData;
	unsigned char EEAddrH;
	unsigned char EEAddrL;
	unsigned char ChkSum;
	unsigned char Buffer[16];

	HANDLE  IntelHex;
	DWORD	NumBytes;

	if ( argc < 2 )
		   {
		    printf("Enter Intel Hex file for upload to Z80 on command line.\n");
		    return 1;
		   }
	IntelHex = CreateFile( argv[1],GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if ( IntelHex == INVALID_HANDLE_VALUE ) { printf("Cannot open %s.\n", argv[1]); return 2; }

	printf ("Z80 in circuit memory programmer\n\n");
	ProgPort = CreateFile( "LPT1", GENERIC_WRITE | GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_FLAG_WRITE_THROUGH, NULL );
	if( ProgPort == NULL ) { printf ( "Unable to access LPT1\n" ); return 3;}
	printf ( "Asserting BUSREQ and waiting 100ms.....\n" );
    Buffer[0] = Z80BUSREQ_L;
	WriteFile( ProgPort, Buffer, 1, &lpNumberOfBytesWritten, NULL );
	Sleep(100);
	printf("Programming");


start:
	do
		{ ReadFile( IntelHex, HexData, 1, &NumBytes, NULL ); }
	while( HexData[0] != ':' && NumBytes == 1 );

	ReadFile( IntelHex, HexData, 8, &NumBytes, NULL );
	//printf ("Read %d bytes\n",NumBytes);

	if( HexData[6] != '0' || NumBytes != 8 ) { goto HexfileError; }
	RecLen = Get8Hex( &HexData[0]);
	EEAddrH = Get8Hex( &HexData[2] ); //printf( "EEAddrH = %.2X\n", EEAddrH );
	EEAddrL = Get8Hex( &HexData[4] ); //printf( "EEAddrL = %.2X\n", EEAddrL );
	ChkSum =   RecLen + EEAddrH + EEAddrL ; //Record type is zero so we don't need to add it in
	RecLen <<= 1; //printf( "RecLen = %.2X\n", RecLen );


	if( HexData[7] == '0' )
		{
		ReadFile( IntelHex, HexData, RecLen, &NumBytes, NULL );
		for ( x=0; x<NumBytes; x+=2)
			{
			EEData = Get8Hex( &HexData[x] );
			WritePort( EEData, EEAddrL,EEAddrH, ProgPort );
			EEAddrL++;
			if (EEAddrL == 0) { EEAddrH++; }
			ChkSum += EEData;
			//printf (".");
			printf( " %.2X,", EEData );
			}

	ReadFile( IntelHex, HexData, 2, &NumBytes, NULL );
	ChkSum += Get8Hex( &HexData[0]);
	if ( ChkSum != 0 ) { printf("Check sum error!\n"); goto HexfileError; }
	//printf( "\nx = %.2X\n", x );
	//printf( "\ny = %.2X\n", y );
	//printf( "\nChkSum = %.2X\n", ChkSum );
	goto start;
		}

	else
		{
			ReadFile( IntelHex, HexData, 2, &NumBytes, NULL );
			ChkSum = Get8Hex( &HexData[0]);
			if( HexData[7] != '1' || ChkSum != 0xFF || NumBytes != 2 )
				{ goto HexfileError; }
			else
				{ printf ("\nSuccessfully programmed!\n"); }
		}


   printf ( "\nResetting.... " );
   Buffer[0] = Z80BUSREQ_H | Z80RESET;
   WriteFile( ProgPort, Buffer, 1, &lpNumberOfBytesWritten, NULL );
   Sleep(100);

   printf ( "Done!\n" );
   Buffer[0] = Z80BUSREQ_H;
   WriteFile( ProgPort, Buffer, 1, &lpNumberOfBytesWritten, NULL );
   Sleep(10);

   CloseHandle( ProgPort );
   CloseHandle( IntelHex );
	return 0;

HexfileError:

	printf ("\nNot a valid Intel Hex file!\n");
	Buffer[0] = Z80BUSREQ_H | Z80RESET;
	WriteFile( ProgPort, Buffer, 1, &lpNumberOfBytesWritten, NULL );
	Sleep(100);
	Buffer[0] = Z80BUSREQ_H;
	WriteFile( ProgPort, Buffer, 1, &lpNumberOfBytesWritten, NULL );
	Sleep(10);
	CloseHandle( ProgPort );
    CloseHandle( IntelHex );
	return 4;
}

int GetHex( unsigned char *AsciiHex )
	{
	  int x;
	  x = AsciiHex[0];
	  if ( x < 0x10 ) { return -1; }
	  if ( x <= 'f' && x >= 'a' ) { x -= 0x20; }
	  if ( x <= 'F' && x >= 'A' ) { x -= 0x37; }
	  if ( x <= '9' && x >= '0' ) { x -= 0x30; }
	  if ( x > 0x0F ) { return -1; }
	  return x;
	 }

int Get8Hex( unsigned char *AsciiHex )
	{
		int x,y;
		x = GetHex( &AsciiHex[0] );
	   	if ( x == -1 ) { return x; }
	    x <<= 4;
		y = GetHex( &AsciiHex[1] );
		if ( y == -1 ) { return y; }
	    x += y;
		return x ; }



void WritePort( unsigned char EEData, unsigned char EEAddrL, unsigned char EEAddrH, HANDLE ProgPort )
	{

	int x, BitSelect;
	unsigned char Buffer[16];
	DWORD  lpNumberOfBytesWritten;

	BitSelect = 0x80; x=0;
	do	{
		   Buffer[x] = 0x00;
		   if ( (BitSelect & EEData) != 0 )
			   { Buffer[x] |= 0x02; }
		   if ( (BitSelect & EEAddrL) != 0 )
			   { Buffer[x] |= 0x04; }
		   if ( (BitSelect & EEAddrH) != 0 )
			   { Buffer[x] |= 0x08; }
		   x++;
		   Buffer[x] = 0x01;
	   	   if ( (BitSelect & EEData) != 0 )
			   { Buffer[x] |= 0x02; }
		   if ( (BitSelect & EEAddrL) != 0 )
			   { Buffer[x] |= 0x04; }
		   if ( (BitSelect & EEAddrH) != 0 )
			   { Buffer[x] |= 0x08; }
		   x++;
		   BitSelect >>= 1;
		   //printf( "x=%d\n", x );
		} while ( x<16 );



	WriteFile( ProgPort, Buffer, 16, &lpNumberOfBytesWritten, NULL );
	//printf ( "Bytes written = %d\n", lpNumberOfBytesWritten );

	Sleep(1);
	Buffer[0] = Z80WR;
	WriteFile( ProgPort, Buffer, 1, &lpNumberOfBytesWritten, NULL );
	Sleep(1);
	Buffer[0] = 0x00;
	WriteFile( ProgPort, Buffer, 1, &lpNumberOfBytesWritten, NULL );
	Sleep(1);

   }

